#-----------------------------------------------------------------------------
# Memorize feet
# Mar 16, 2006
# by Ockham
# Goes with the ResFeet.py script.  MemFeet gathers the actual center of
# the feet, and loc of Body, on the current figure and stores in file "feet.dat".
# ResFeet picks up that file (if present) and moves the current figure
# so its feet are centered in the same place.

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

import poser
import pickle

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

scene=poser.Scene()
CurFig=scene.CurrentFigure()
if not CurFig: raise "No figure selected"

BasePathUncut = poser.AppLocation()
BasePath = BasePathUncut[:(-len("poser.exe"))]
DatName=os.path.join(BasePath,'runtime','feet.dat')

try:
    Lfoot=CurFig.ActorByInternalName("lFoot")
    Rfoot=CurFig.ActorByInternalName("rFoot")
except:
    raise "Figure doesn't have feet"
try:
    Lgeom=Lfoot.Geometry()
    Rgeom=Rfoot.Geometry()
except:
    raise "No mesh?"
# Form average center
scene.DrawAll()
LMaxX=-10000.0
LMaxZ=-10000.0
LMinX= 10000.0
LMinZ= 10000.0
RMaxX=-10000.0
RMaxZ=-10000.0
RMinX= 10000.0
RMinZ= 10000.0
for v in range(Lgeom.NumVertices()):
    LWV=Lgeom.WorldVertex(v)
    if   LWV.X()>LMaxX: LMaxX=LWV.X()
    elif LWV.X()<LMinX: LMinX=LWV.X()
    if   LWV.Z()>LMaxZ: LMaxZ=LWV.Z()
    elif LWV.Z()<LMinZ: LMinZ=LWV.Z()
    RWV=Rgeom.WorldVertex(v)
    if   RWV.X()>RMaxX: RMaxX=RWV.X()
    elif RWV.X()<RMinX: RMinX=RWV.X()
    if   RWV.Z()>RMaxZ: RMaxZ=RWV.Z()
    elif RWV.Z()<RMinZ: RMinZ=RWV.Z()
LX=(LMaxX+LMinX)/2.0
LZ=(LMaxZ+LMinZ)/2.0
RX=(RMaxX+RMinX)/2.0
RZ=(RMaxZ+RMinZ)/2.0
# Now we have the actual center of the feet.
# Store this:
fp=open(DatName,"wt")
Desired=(LX,LZ,RX,RZ)
pickle.dump(Desired,fp)
fp.close()

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
